"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

class Secret(google.protobuf.message.Message):
    """Secret encapsulates information about the secret a task needs to proceed. An environment variable
    FLYTE_SECRETS_ENV_PREFIX will be passed to indicate the prefix of the environment variables that will be present if
    secrets are passed through environment variables.
    FLYTE_SECRETS_DEFAULT_DIR will be passed to indicate the prefix of the path where secrets will be mounted if secrets
    are passed through file mounts.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class MountType(_MountType, metaclass=_MountTypeEnumTypeWrapper):
        pass
    class _MountType:
        V = typing.NewType('V', builtins.int)
    class _MountTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_MountType.V], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor = ...
        ANY = Secret.MountType.V(0)
        """Default case, indicates the client can tolerate either mounting options."""

        ENV_VAR = Secret.MountType.V(1)
        """ENV_VAR indicates the secret needs to be mounted as an environment variable."""

        FILE = Secret.MountType.V(2)
        """FILE indicates the secret needs to be mounted as a file."""


    ANY = Secret.MountType.V(0)
    """Default case, indicates the client can tolerate either mounting options."""

    ENV_VAR = Secret.MountType.V(1)
    """ENV_VAR indicates the secret needs to be mounted as an environment variable."""

    FILE = Secret.MountType.V(2)
    """FILE indicates the secret needs to be mounted as a file."""


    GROUP_FIELD_NUMBER: builtins.int
    GROUP_VERSION_FIELD_NUMBER: builtins.int
    KEY_FIELD_NUMBER: builtins.int
    MOUNT_REQUIREMENT_FIELD_NUMBER: builtins.int
    group: typing.Text = ...
    """The name of the secret group where to find the key referenced below. For K8s secrets, this should be the name of
    the v1/secret object. For Confidant, this should be the Credential name. For Vault, this should be the secret name.
    For AWS Secret Manager, this should be the name of the secret.
    +required
    """

    group_version: typing.Text = ...
    """The group version to fetch. This is not supported in all secret management systems. It'll be ignored for the ones
    that do not support it.
    +optional
    """

    key: typing.Text = ...
    """The name of the secret to mount. This has to match an existing secret in the system. It's up to the implementation
    of the secret management system to require case sensitivity. For K8s secrets, Confidant and Vault, this should
    match one of the keys inside the secret. For AWS Secret Manager, it's ignored.
    +optional
    """

    mount_requirement: global___Secret.MountType.V = ...
    """mount_requirement is optional. Indicates where the secret has to be mounted. If provided, the execution will fail
    if the underlying key management system cannot satisfy that requirement. If not provided, the default location
    will depend on the key management system.
    +optional
    """

    def __init__(self,
        *,
        group : typing.Text = ...,
        group_version : typing.Text = ...,
        key : typing.Text = ...,
        mount_requirement : global___Secret.MountType.V = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal[u"group",b"group",u"group_version",b"group_version",u"key",b"key",u"mount_requirement",b"mount_requirement"]) -> None: ...
global___Secret = Secret

class OAuth2Client(google.protobuf.message.Message):
    """OAuth2Client encapsulates OAuth2 Client Credentials to be used when making calls on behalf of that task."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    CLIENT_ID_FIELD_NUMBER: builtins.int
    CLIENT_SECRET_FIELD_NUMBER: builtins.int
    client_id: typing.Text = ...
    """client_id is the public id for the client to use. The system will not perform any pre-auth validation that the
    secret requested matches the client_id indicated here.
    +required
    """

    @property
    def client_secret(self) -> global___Secret:
        """client_secret is a reference to the secret used to authenticate the OAuth2 client.
        +required
        """
        pass
    def __init__(self,
        *,
        client_id : typing.Text = ...,
        client_secret : typing.Optional[global___Secret] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal[u"client_secret",b"client_secret"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal[u"client_id",b"client_id",u"client_secret",b"client_secret"]) -> None: ...
global___OAuth2Client = OAuth2Client

class Identity(google.protobuf.message.Message):
    """Identity encapsulates the various security identities a task can run as. It's up to the underlying plugin to pick the
    right identity for the execution environment.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    IAM_ROLE_FIELD_NUMBER: builtins.int
    K8S_SERVICE_ACCOUNT_FIELD_NUMBER: builtins.int
    OAUTH2_CLIENT_FIELD_NUMBER: builtins.int
    iam_role: typing.Text = ...
    """iam_role references the fully qualified name of Identity & Access Management role to impersonate."""

    k8s_service_account: typing.Text = ...
    """k8s_service_account references a kubernetes service account to impersonate."""

    @property
    def oauth2_client(self) -> global___OAuth2Client:
        """oauth2_client references an oauth2 client. Backend plugins can use this information to impersonate the client when
        making external calls.
        """
        pass
    def __init__(self,
        *,
        iam_role : typing.Text = ...,
        k8s_service_account : typing.Text = ...,
        oauth2_client : typing.Optional[global___OAuth2Client] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal[u"oauth2_client",b"oauth2_client"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal[u"iam_role",b"iam_role",u"k8s_service_account",b"k8s_service_account",u"oauth2_client",b"oauth2_client"]) -> None: ...
global___Identity = Identity

class OAuth2TokenRequest(google.protobuf.message.Message):
    """OAuth2TokenRequest encapsulates information needed to request an OAuth2 token.
    FLYTE_TOKENS_ENV_PREFIX will be passed to indicate the prefix of the environment variables that will be present if
    tokens are passed through environment variables.
    FLYTE_TOKENS_PATH_PREFIX will be passed to indicate the prefix of the path where secrets will be mounted if tokens
    are passed through file mounts.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class Type(_Type, metaclass=_TypeEnumTypeWrapper):
        """Type of the token requested."""
        pass
    class _Type:
        V = typing.NewType('V', builtins.int)
    class _TypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_Type.V], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor = ...
        CLIENT_CREDENTIALS = OAuth2TokenRequest.Type.V(0)
        """CLIENT_CREDENTIALS indicates a 2-legged OAuth token requested using client credentials."""


    CLIENT_CREDENTIALS = OAuth2TokenRequest.Type.V(0)
    """CLIENT_CREDENTIALS indicates a 2-legged OAuth token requested using client credentials."""


    NAME_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    CLIENT_FIELD_NUMBER: builtins.int
    IDP_DISCOVERY_ENDPOINT_FIELD_NUMBER: builtins.int
    TOKEN_ENDPOINT_FIELD_NUMBER: builtins.int
    name: typing.Text = ...
    """name indicates a unique id for the token request within this task token requests. It'll be used as a suffix for
    environment variables and as a filename for mounting tokens as files.
    +required
    """

    type: global___OAuth2TokenRequest.Type.V = ...
    """type indicates the type of the request to make. Defaults to CLIENT_CREDENTIALS.
    +required
    """

    @property
    def client(self) -> global___OAuth2Client:
        """client references the client_id/secret to use to request the OAuth2 token.
        +required
        """
        pass
    idp_discovery_endpoint: typing.Text = ...
    """idp_discovery_endpoint references the discovery endpoint used to retrieve token endpoint and other related
    information.
    +optional
    """

    token_endpoint: typing.Text = ...
    """token_endpoint references the token issuance endpoint. If idp_discovery_endpoint is not provided, this parameter is
    mandatory.
    +optional
    """

    def __init__(self,
        *,
        name : typing.Text = ...,
        type : global___OAuth2TokenRequest.Type.V = ...,
        client : typing.Optional[global___OAuth2Client] = ...,
        idp_discovery_endpoint : typing.Text = ...,
        token_endpoint : typing.Text = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal[u"client",b"client"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal[u"client",b"client",u"idp_discovery_endpoint",b"idp_discovery_endpoint",u"name",b"name",u"token_endpoint",b"token_endpoint",u"type",b"type"]) -> None: ...
global___OAuth2TokenRequest = OAuth2TokenRequest

class SecurityContext(google.protobuf.message.Message):
    """SecurityContext holds security attributes that apply to tasks."""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    RUN_AS_FIELD_NUMBER: builtins.int
    SECRETS_FIELD_NUMBER: builtins.int
    TOKENS_FIELD_NUMBER: builtins.int
    @property
    def run_as(self) -> global___Identity:
        """run_as encapsulates the identity a pod should run as. If the task fills in multiple fields here, it'll be up to the
        backend plugin to choose the appropriate identity for the execution engine the task will run on.
        """
        pass
    @property
    def secrets(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___Secret]:
        """secrets indicate the list of secrets the task needs in order to proceed. Secrets will be mounted/passed to the
        pod as it starts. If the plugin responsible for kicking of the task will not run it on a flyte cluster (e.g. AWS
        Batch), it's the responsibility of the plugin to fetch the secret (which means propeller identity will need access
        to the secret) and to pass it to the remote execution engine.
        """
        pass
    @property
    def tokens(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___OAuth2TokenRequest]:
        """tokens indicate the list of token requests the task needs in order to proceed. Tokens will be mounted/passed to the
        pod as it starts. If the plugin responsible for kicking of the task will not run it on a flyte cluster (e.g. AWS
        Batch), it's the responsibility of the plugin to fetch the secret (which means propeller identity will need access
        to the secret) and to pass it to the remote execution engine.
        """
        pass
    def __init__(self,
        *,
        run_as : typing.Optional[global___Identity] = ...,
        secrets : typing.Optional[typing.Iterable[global___Secret]] = ...,
        tokens : typing.Optional[typing.Iterable[global___OAuth2TokenRequest]] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal[u"run_as",b"run_as"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal[u"run_as",b"run_as",u"secrets",b"secrets",u"tokens",b"tokens"]) -> None: ...
global___SecurityContext = SecurityContext
